#!/usr/bin/perl
# This Script and the readme may only be given away "as is", unmodified
# and complete.
# By http://www.PopupNow.com
# on 25.12.98

require "./config.cgi";
require "./shared.cgi";
require "./$messages_dir/chat.cgi";
require "./$messages_dir/shared.cgi";
require "./$html_dir/chatinput.cgi";
require "./$html_dir/user_error.cgi";


# Main Part - DON'T CHANGE ANYTHING HERE!
#
#######################

&action;


exit;

sub action {
	if ($query{'action'} eq "chatinput_html") {
		&chatinput_html;
	}
	elsif ($query{'action'} eq "postmsg") {
	    &checkpass;
	    if (substr($query{'msg'},0,1) eq "/" ) { # msg = command?
		&command("$query{'msg'}");    
	    } elsif ($query{'msg_to'} ne "") {
		&command("/msg $query{'msg_to'} $query{'msg'}");
	    } else {
		&postmsg("public", $query{'name'}, "", $query{'msg'});
	    }
	    &chatinput_html;
	}
	else {
		&error;
	} 
}

sub select_user {
    print "<SELECT MAXLENGTH=2 NAME=\"msg_to\">";
    print "<OPTION VALUE=\"\">$chat_msg[21]</OPTION>";
    if ($use_dbi) {
    } else {
	open (SAFILE, "<$data_dir/$data_stillalive") || &error("opening safile failed");
	
	while (split(/;;/, <SAFILE>)) {
	    $points = (length($_[0]) > 9) ? ".." : "";
	    my $shortnick = substr($_[0],0,9).$points;
	    $selected = ($query{'msg_to'} eq $_[0] && !$reset_private_msg_select) ? "SELECTED" : "";
	    print "<OPTION $selected VALUE=\"$_[0]\">$shortnick</OPTION>";
	}
	close SAFILE;
    }
    print "</SELECT>";
}

sub command { # Kommandoprozedur fuer /cmd ; parameter 0: commandstring
    $_[0] = $_[0]." "; # add trailing space
    $_[0] =~ s/^\///; # remove /
    my @cmdargs = split(/ /, $_[0]);
    my $cmd = lc($cmdargs[0]);
    my $cmdarg = substr($_[0], index($_[0], " ")+1);

    # check userlevel (set in checkpass)
    if ($ul{$cmd} > $userlevel) {
	&postmsg("command", "USERLEVEL", $query{'name'}, "$chat_msg[35] $cmd");
    } elsif ($cmd eq "msg") { # /msg msgto msg
	$cmdarg = substr($cmdarg, index($cmdarg, " ")+1);
	if ($cmdarg =~ /\S/) { # if not empty
	    &postmsg("private", $query{'name'}, $cmdargs[1], "$cmdarg"); 
	    &postmsg("private_out", $cmdargs[1], $query{'name'}, "$cmdarg");
	}
    } elsif ($cmd eq "help") {
	&postmsg("command", "HELP", $query{'name'}, $chat_msg[3]);
    } elsif ($cmd eq "help_master") {
	&postmsg("command", "HELP_MASTER", $query{'name'}, $chat_msg[34]);
    } elsif ($cmd eq "about") {
	&postmsg("command", "ABOUT", $query{'name'}, $about_msg);
    } elsif ($cmd eq "me") {
	&postmsg("me", $query{'name'}, "", $cmdarg);
    } elsif ($cmd eq "list_nicks") { # /listnicks
	&list_nicks;
    } elsif ($cmd eq "clean_old_nicks") { # /clean_old_nicks cleandate
	if ($cmdargs[1] >= 1) {
	    &remove_nick("", $cmdargs[1]);
	} else {
	    &postmsg("command", "CLEAN_OLD_NICKS", $query{'name'}, $chat_msg[2]);
	}
    } elsif ($cmd eq "remove_nick") { # /remove_nick nick
	&remove_nick($cmdargs[1]);
    } elsif ($cmd eq "userinfo") { # /userinfo nick
	if (&userinfo($cmdargs[1])) {
	    &postmsg("command", "USERINFO", $query{'name'}, "<B>$cmdargs[1]</B><BR>$config_msg[11]: $userinfo{'realname'}<BR>$config_msg[12]: <A HREF=\"mailto:$userinfo{'email'}\">$userinfo{'email'}</A><BR>$config_msg[13]: $userinfo{'age'}<BR>$config_msg[14]: $userinfo{'city'}<BR>$config_msg[15]: $userinfo{'country'}<BR>$config_msg[16]: <A HREF=\"$userinfo{'url'}\">$userinfo{'url'}</A><BR>$config_msg[17]: $userinfo{'stuff'}<BR>$config_msg[18]: <A HREF=\"$userinfo{'photo_url'}\">$userinfo{'photo_url'}</A>");
	} else {
	    &postmsg("command", "USERINFO", $query{'name'}, "$config_msg[9] $cmdargs[1] $config_msg[10]");
	}
    } elsif ($cmd eq "ban") {
	&kick_or_ban_nick($cmdargs[1], 2);
    } elsif ($cmd eq "kick") {
	&kick_or_ban_nick($cmdargs[1], 1);
    } elsif ($cmd eq "banned_list") {
	&banned_list;
    } elsif ($cmd eq "unban") {
	&unban($cmdargs[1], 2);
    } elsif ($cmd eq "memo") { # /memo memoto memo
	$cmdarg = substr($cmdarg, index($cmdarg, " ")+1);
	&memo($cmdargs[1],$query{'name'}, $cmdarg);
    } elsif ($cmd eq "ip") {
	&ip($cmdargs[1]);
    } elsif ($cmd eq "admin_memo") { # /admin_memo memo
	&admin_memo($query{'name'}, $cmdarg);
    } elsif ($cmd eq "away") { # /away msg
	&away($cmdarg);
    } elsif ($cmd eq "userlevel") { # /userlevel nick level [mpw]
	if ($userlevel > $cmdargs[2] or $cmdargs[3] eq $masterpassword) {
	    &set_ul($cmdargs[1], $cmdargs[2]);
	} else {
	    &postmsg("command", "USERLEVEL", $query{'name'}, $chat_msg[36]);
	}
    } else {
	&postmsg("command", "HELP", $query{'name'}, "$chat_msg[1]: $cmd");
    }
}

sub list_nicks {
    my $nicklist = "<TABLE><TR><TD><B>$chat_msg[8]</B></TD><TD><B>$config_msg[12]</B></TD><TD><B>$chat_msg[9]</B></TD><TD><B>$chat_msg[10]</B></TD><TD><B>$chat_msg[11]</B></TD><TD><B>$chat_msg[12]</B></TD><TD><B>$chat_msg[13]</B></TD><TD><B>$chat_msg[39]</B></TR>";
    my $nrnicks;
    
    if ($use_dbi) {
    } else {
	open (NICKFILE, "<$data_dir/$data_nicks") || &error("::open Nickfile failed::");
	while (<NICKFILE>) {
	    chomp;
	    my @nick = split(/;;/);
	    my $status = $chat_msg[14];
	    $status = $chat_msg[15] if ($nick[10] == 1);
	    $status = $chat_msg[16] if ($nick[10] == 2);
	    $nicklist = "$nicklist<TR><TD>$nick[0]</TD><TD>$nick[2]</TD><TD>$nick[3]</TD><TD>".localtime($nick[4])."</TD><TD>$nick[11]</TD><TD>$status</TD><TD>$nick[12]</TD><TD>$ul_names{$nick[7]}</TD></TR>";
	    $nrnicks++;
	}
	close NICKFILE;
    }
    
    $nicklist = "$nicklist</TABLE> $chat_msg[33] $nrnicks";
    &postmsg("command", "LIST_NICKS", $query{'name'}, $nicklist);
}

sub remove_nick { # remove nick $_[0] or all nicks older than $_[1]
    my $removed_users;
    my $removed_users_names;
    my $oldtime = time - $_[1]*60*60*24;
    if ($use_dbi) {
    } else {
	# wait until other process finished working on the stillalive file
	while (-e "$data_dir/$data_nicks.tmp") { 
	    sleep 1;
	    $file_tmp++;
	    if ($file_tmp > 30) {
		unlink(glob("$data_dir/*.tmp"));
		$file_tmp = 0;
	    }
	}

	open (NICKFILE, "<$data_dir/$data_nicks");
	open (NICKFILE2, ">$data_dir/$data_nicks.tmp") || &error("::open nicks2 file failed::");
	flock(NICKFILE2,2) if ($flocking == 1);

	my @row;
	while (<NICKFILE>) {
	    @row = split(/;;/);
	    if (($_[0] and lc($row[0]) eq lc($_[0])) or ($_[1] and $row[4] < $oldtime)) {
		$removed_users_names .= " $row[0]";
		$removed_users++;

		# remove memos
		open (MEMOFILE, "<$data_dir/$data_memo");
		open (MEMOFILE2, ">$data_dir/$data_memo.tmp") || &error("::open memo2 file failed::");
		flock(MEMOFILE2,2) if ($flocking == 1);
		while (<MEMOFILE>) {
		    if (!/^\Q$row[0]\E;;/i) {
			print MEMOFILE2;
		    }
		}
		close MEMOFILE;
		close MEMOFILE2;
		unlink("$data_dir/$data_memo");
		rename("$data_dir/$data_memo.tmp", "$data_dir/$data_memo");
		

		# remove userinfo
		open (UIFILE, "<$data_dir/$data_userinfo");
		open (UIFILE2, ">$data_dir/$data_userinfo.tmp") || &error("::open userinfo2 file failed::");
		flock(UIFILE2,2) if ($flocking == 1);
		while (<UIFILE>) {
		    if (!/^\Q$row[0]\E;;/i) {
			print UIFILE2;
		    }
		}
		close UIFILE;
		close UIFILE2;
		unlink("$data_dir/$data_userinfo");
		rename("$data_dir/$data_userinfo.tmp", "$data_dir/$data_userinfo");
	    } else {
		print NICKFILE2;
	    }
	}

	close NICKFILE;
	close NICKFILE2;
	unlink("$data_dir/$data_nicks");
	rename("$data_dir/$data_nicks.tmp", "$data_dir/$data_nicks");
    }

    if ($_[1]) {
	&postmsg("command", "CLEAN_OLD_NICKS", "$query{'name'}","$chat_msg[17]: $removed_users_names<BR>$chat_msg[18]: $removed_users");
    } elsif ($_[0]) {
	if ($removed_users) {
	    &postmsg("command", "REMOVE_NICK", "$query{'name'}","$chat_msg[6] $_[0] $chat_msg[19]");
	} else {
	    &postmsg("command", "REMOVE_NICK", "$query{'name'}","$chat_msg[6] $_[0] $chat_msg[20]");
	}		
    }

    # LOG ACTION
    if ($logtype >= 1) {
	open (LOGFILE, ">>$log_dir/$log_file") || &error("::open $log_dir/$log_file failed::");
	flock(LOGFILE,2) if ($flocking == 1);
	# $_[1]
	print LOGFILE localtime(time)." $ENV{'REMOTE_ADDR'} [CLEAN_OLD_NICKS] $chat_msg[17]: $removed_users_names\n" if ($_[1]);
	# $_[0]
	print LOGFILE localtime(time)." $ENV{'REMOTE_ADDR'} [REMOVE_NICK] $_[0] $chat_msg[19]\n" if ($_[0]);
	close LOGFILE;
    }

}



sub kick_or_ban_nick { # $_[0] nick to kick/ban, $_[1] banlevel (1=kick, 2=ban)
    if ($_[0] =~ /^ip:/i) {
	if ($use_dbi) {
	} else {	
	    open (BANFILE, ">>$data_dir/$data_banned");
	    flock(BANFILE,2) if ($flocking == 1); 
	    print BANFILE "$_[0]\n";
	    close BANFILE;
	}
	&postmsg("command", "BAN", "$query{'name'}","IP ".substr($_[0],3)." $chat_msg[16]");
	return;
    }

    if ($use_dbi) {
    } else {
	# wait until other process finished working on the nicks file
	while (-e "$data_dir/$data_nicks.tmp") { 
	    sleep 1;
	    $file_tmp++;
	    if ($file_tmp > 30) {
		unlink(glob("$data_dir/*.tmp"));
		$file_tmp = 0;
	    }
	}

	open (NICKFILE, "<$data_dir/$data_nicks");
	open (NICKFILE2, ">$data_dir/$data_nicks.tmp") || &error("::open nicks2 file failed::");
	flock(NICKFILE2,2) if ($flocking == 1);
	
	while (<NICKFILE>) {
	    if (/^\Q$_[0]\E;;/i) {
		chomp;
		my @row = split(/;;/);
		$row[10] = $_[1];
		print NICKFILE2 join(';;', @row)."\n";
	    } else {
		print NICKFILE2;
	    }
	}
	
	close NICKFILE;
	close NICKFILE2;
	unlink("$data_dir/$data_nicks");
	rename("$data_dir/$data_nicks.tmp", "$data_dir/$data_nicks");

	if ($_[1] == 2) {
	    open (BANFILE, ">>$data_dir/$data_banned") || &error("::open banned file failed::");
	    flock(BANFILE,2) if ($flocking);
	    print BANFILE "$_[0]\n";
	    close BANFILE;
	}
    }
    # post msg
    if ($_[1] == 1) {
	&postmsg("command", "KICK", "$query{'name'}", "User $_[0] $chat_msg[15]");
    } elsif ($_[1] == 2) {
	&postmsg("command", "BAN", "$query{'name'}", "User $_[0] $chat_msg[16]");
    }

}    

sub banned_list {
    my $banned;
    if ($use_dbi) {
    } else {
	open (BANFILE, "<$data_dir/$data_banned");
	while (<BANFILE>) {
	    chomp;
	    $banned .= "<BR>$_";
	}
	close BANFILE;
    }
    &postmsg("command", "BANNED_LIST", "$query{'name'}","<B>$chat_msg[16]:</B>$banned");
}

sub unban {
    if ($use_dbi) {
    } else {
	# remove from banned file
	while (-e "$data_dir/$data_banned.tmp") { 
	    sleep 1;
	    $file_tmp++;
	    if ($file_tmp > 30) {
		unlink(glob("$data_dir/*.tmp"));
		$file_tmp = 0;
	    }
	}
	open (BANFILE, "<$data_dir/$data_banned");
	open (BANFILE2, ">$data_dir/$data_banned.tmp") || &error("::open banned2 file failed::");
	flock(BANFILE2,2) if ($flocking == 1);
	while (<BANFILE>) {
	    if (!/^\Q$_[0]\E$/i) {
		print BANFILE2;
	    }
	}
	close BANFILE;
	close BANFILE2;
	unlink("$data_dir/$data_banned");
	rename("$data_dir/$data_banned.tmp", "$data_dir/$data_banned");

	# set banlevel to 0
	# wait until other process finished working on the nicks file
	while (-e "$data_dir/$data_nicks.tmp") { 
	    sleep 1;
	    $file_tmp++;
	    if ($file_tmp > 30) {
		unlink(glob("$data_dir/*.tmp"));
		$file_tmp = 0;
	    }
	}

	open (NICKFILE, "<$data_dir/$data_nicks");
	open (NICKFILE2, ">$data_dir/$data_nicks.tmp") || &error("::open nicks2 file failed::");
	flock(NICKFILE2,2) if ($flocking == 1);
	
	while (<NICKFILE>) {
	    if (/^\Q$_[0]\E;;/i) {
		chomp;
		my @row = split(/;;/);
		$row[10] = 0;
		print NICKFILE2 join(';;', @row)."\n";
	    } else {
		print NICKFILE2;
	    }
	}
	
	close NICKFILE;
	close NICKFILE2;
	unlink("$data_dir/$data_nicks");
	rename("$data_dir/$data_nicks.tmp", "$data_dir/$data_nicks");
    }
    &postmsg("command", "UNBAN", "$query{'name'}","$chat_msg[6] $_[0] $chat_msg[22]");
}

sub memo {
    my $memo_msg_to   = $_[0];
    my $memo_msg_from = $_[1];
    my $memo_msg      = &wash_msg($_[2]);
    my $memo_time     = $timestamp;
    if ($use_dbi) {
    } else {
	# wait until other process finished working on the nicks file
	while (-e "$data_dir/$data_nicks.tmp") { 
	    sleep 1;
	    $file_tmp++;
	    if ($file_tmp > 30) {
		unlink(glob("$data_dir/*.tmp"));
		$file_tmp = 0;
	    }
	}

	open (NICKFILE, "<$data_dir/$data_nicks");
	open (NICKFILE2, ">$data_dir/$data_nicks.tmp") || &error("::open nicks2 file failed::");
	flock(NICKFILE2,2) if ($flocking == 1);
	
	my $userfound;
	while (<NICKFILE>) {
	    if (/^\Q$_[0]\E;;/i) {
		chomp;
		my @row = split(/;;/);
		$row[12]++;
		$userfound = 1;
		print NICKFILE2 join(';;', @row)."\n";
	    } else {
		print NICKFILE2;
	    }
	}
	
	close NICKFILE;
	close NICKFILE2;
	unlink("$data_dir/$data_nicks");
	rename("$data_dir/$data_nicks.tmp", "$data_dir/$data_nicks");

	if (!$userfound) {
		&postmsg("command", "MEMO", "$query{'name'}","$chat_msg[6] $_[0] $chat_msg[20]");
		return;
	}

	open (MEMOFILE, ">>$data_dir/$data_memo") || &error("opening memofile failed");
	flock(MEMOFILE,2) if ($flocking == 1); 
	print MEMOFILE "$memo_msg_to;;$memo_msg_from;;$memo_msg;;$memo_time\n";
	close MEMOFILE;
    }
    &postmsg("command", "MEMO", "$query{'name'}","$chat_msg[23] $_[0] $chat_msg[24]");
}

sub admin_memo {
    my $memo_msg_to = $chat_msg[25];
    my $memo_msg_from = $_[0];
    my $memo_msg = $_[1];

    if ($use_dbi) {
    } else {
	# wait until other process finished working on the nicks file
	while (-e "$data_dir/$data_nicks.tmp") { 
	    sleep 1;
	    $file_tmp++;
	    if ($file_tmp > 30) {
		unlink(glob("$data_dir/*.tmp"));
		$file_tmp = 0;
	    }
	}

	open (NICKFILE, "<$data_dir/$data_nicks");
	open (NICKFILE2, ">$data_dir/$data_nicks.tmp") || &error("::open nicks2 file failed::");
	flock(NICKFILE2,2) if ($flocking == 1);
	open (MEMOFILE, ">>$data_dir/$data_memo") || &error("opening memofile failed");
	flock(MEMOFILE,2) if ($flocking == 1); 
	
	my @row;
	while (<NICKFILE>) {
	    chomp;
	    @row = split(/;;/);
	    $row[12]++;
	    print NICKFILE2 join(';;', @row)."\n";
	    print MEMOFILE "$row[0];;$memo_msg_from;;$memo_msg;;$timestamp\n";
	}
	
	close MEMOFILE;
	close NICKFILE;
	close NICKFILE2;
	unlink("$data_dir/$data_nicks");
	rename("$data_dir/$data_nicks.tmp", "$data_dir/$data_nicks");
    }
    &postmsg("command", "ADMIN_MEMO", "$query{'name'}","$chat_msg[23] $memo_msg_to $chat_msg[24]");
}

sub ip {
    my $ip;
    if ($use_dbi) {
    } else {
	open (NICKFILE, "<$data_dir/$data_nicks");
	while (<NICKFILE>) {
	    if (/^\Q$_[0]\E;;/i) {
		$ip = (split(/;;/))[11];
		last;
	    }
	}
	close NICKFILE;
    }
    if ($ip) {
	&postmsg("command", "IP", "$query{'name'}","$_[0]: $ip");	
    } else {
	&postmsg("command", "IP", "$query{'name'}","$config_msg[1]");	
    }
}

sub select_action {
    if (%actions) {
	print "<SELECT MAXLENGTH=2 NAME=\"selected_action\">";
	print "<OPTION SELECTED VALUE=\"\">Action:</OPTION>";
	while ((my $key, my $value) = each %actions) {
	    print "<OPTION VALUE=\"$key\">$key</OPTION>";
	}
	print "</SELECT>";
    }
}


# handle command /away
sub away { # 0 reason
    &wash_msg($_[0]);
    if ($use_dbi) {
    } else {
	# wait until other process finished working on the stillalive file
	while (-e "$data_dir/$data_stillalive.tmp") { 
	    sleep 1;
	    $file_tmp++;
	    if ($file_tmp > 30) {
		unlink(glob("$data_dir/*.tmp"));
		$file_tmp = 0;
	    }
	}

	open (SAFILE, "<$data_dir/$data_stillalive");
	open (SAFILE2, ">$data_dir/$data_stillalive.tmp") || &error("::open stillalive2 file failed::");
	flock(SAFILE2,2) if ($flocking == 1);
	
	while (<SAFILE>) {
	    if (/^\Q$query{'name'}\E;;/i) {
		chomp;
		my @row = split(/;;/);
		if ($row[2] == 1) { # set back again
		    &postmsg("command", "AWAY","$query{'name'}","$chat_msg[29]");
		    &postmsg("command", "AWAY", "", "<B>$query{'name'} $chat_msg[32] $_[0]</B>");
		    $row[2] = 0;
		} else { # set away
		    &postmsg("command", "AWAY", "$query{'name'}","$chat_msg[28]");		
		    &postmsg("command", "AWAY", "", "<B>$query{'name'} $chat_msg[31] $_[0]</B>");
		    $row[2] = 1;
		}
		print SAFILE2 join(';;', @row)."\n";
	    } else {
		print SAFILE2;
	    }
	}
	
	close SAFILE;
	close SAFILE2;
	unlink("$data_dir/$data_stillalive");
	rename("$data_dir/$data_stillalive.tmp", "$data_dir/$data_stillalive");
    }
}

# Set Userlevel
sub set_ul { # 0 - nick, 1 - level
    if ($use_dbi) {
    } else {
	# wait until other process finished working on the nicks file
	while (-e "$data_dir/$data_nicks.tmp") { 
	    sleep 1;
	    $file_tmp++;
	    if ($file_tmp > 30) {
		unlink(glob("$data_dir/*.tmp"));
		$file_tmp = 0;
	    }
	}

	open (NICKFILE, "<$data_dir/$data_nicks");
	open (NICKFILE2, ">$data_dir/$data_nicks.tmp") || &error("::open nicks2 file failed::");
	flock(NICKFILE2,2) if ($flocking == 1);
	
	while (<NICKFILE>) {
	    if (/^\Q$_[0]\E;;/i) {
		chomp;
		my @row = split(/;;/);
		$row[7] = $_[1];
		print NICKFILE2 join(';;', @row)."\n";
	    } else {
		print NICKFILE2;
	    }
	}
	
	close NICKFILE;
	close NICKFILE2;
	unlink("$data_dir/$data_nicks");
	rename("$data_dir/$data_nicks.tmp", "$data_dir/$data_nicks");
    }
    &postmsg("command", "USERLEVEL", "$query{'name'}","$chat_msg[37] $_[0] $chat_msg[38] $_[1]");
    
}
